注:本次实验使用的服务器的IP地址为:172.16.4.1
设计与实现
一、编译安装apache
1、解决依赖关系
由于httpd-2.4.1的安装需要较新版本的apr和apr-util这两个包,因此需要事先对其进行升级。需要用到的包有apr包和其apr-devel包以及apr-util和apr-util-devel包,如下:
apr-1.4.6-1.i386.rpm
apr-devel-1.4.6-1.i386.rpm
apr-util-1.4.1-1.i386.rpm
apr-util-devel-1.4.1-1.i386.rpm
下载地址:http://down.51cto.com/data/361554
下载上述四个包后,对其进行升级,这里笔者电脑是32位的,所以选择i386的,执行以下命令:
#rpm –Uvh apr-1.4.6-1.i386.rpm apr-devel-1.4.6-1.i386.rpm apr-util-1.4.1-1.i386.rpm apr-util-devel-1.4.1-1.i386.rpm
另外,httpd-2.4.1编译过程也要依赖于pcre-devel软件包,需要事先安装,所以配置好yum源,执行以下命令:
#yum install pcre-devel -y
2、编译安装httpd-2.4.1
首先下载httpd-2.4.1到本地。下载地址:
http://labs.renren.com/apache-mirror//httpd/httpd-2.4.1.tar.bz2
而后执行如下命令进行编译安装过程:
- # tar xf httpd-2.4.1.tar.bz2
- # cd httpd-2.4.1
- #./configure --prefix=/usr/local/apache --sysconfdir=/etc/httpd --enable-so --enable-ssl --enable-cgi --enable-rewrite --with-zlib
- # make && make install
3、修改httpd的主配置文件,设置其Pid文件的存放位置,根据redhat的风格,这里将其设置为/var/run/下。
编辑/etc/httpd/httpd.conf,添加如下行即可:
PidFile "/var/run/httpd.pid"
4、为httpd提供SysV服务脚本/etc/rc.d/init.d/httpd,内容如下:
- #!/bin/bash
- #
- # httpd Startup script for the Apache HTTP Server
- #
- # chkconfig: - 85 15
- # description: Apache is a World Wide Web server. It is used to serve \
- # HTML files and CGI.
- # processname: httpd
- # config: /etc/httpd/conf/httpd.conf
- # config: /etc/sysconfig/httpd
- # pidfile: /var/run/httpd.pid
- # Source function library.
- . /etc/rc.d/init.d/functions
- if [ -f /etc/sysconfig/httpd ]; then
- . /etc/sysconfig/httpd
- fi
- # Start httpd in the C locale by default.
- HTTPD_LANG=${HTTPD_LANG-"C"}
- # This will prevent initlog from swallowing up a pass-phrase prompt if
- # mod_ssl needs a pass-phrase from the user.
- INITLOG_ARGS=""
- # Set HTTPD=/usr/sbin/httpd.worker in /etc/sysconfig/httpd to use a server
- # with the thread-based "worker" MPM; BE WARNED that some modules may not
- # work correctly with a thread-based MPM; notably PHP will refuse to start.
- # Path to the apachectl script, server binary, and short-form for messages.
- apachectl=/usr/local/apache/bin/apachectl
- httpd=${HTTPD-/usr/local/apache/bin/httpd}
- prog=httpd
- pidfile=${PIDFILE-/var/run/httpd.pid}
- lockfile=${LOCKFILE-/var/lock/subsys/httpd}
- RETVAL=0
- start() {
- echo -n $"Starting $prog: "
- LANG=$HTTPD_LANG daemon --pidfile=${pidfile} $httpd $OPTIONS
- RETVAL=$?
- echo
- [ $RETVAL = 0 ] && touch ${lockfile}
- return $RETVAL
- }
- stop() {
- echo -n $"Stopping $prog: "
- killproc -p ${pidfile} -d 10 $httpd
- RETVAL=$?
- echo
- [ $RETVAL = 0 ] && rm -f ${lockfile} ${pidfile}
- }
- reload() {
- echo -n $"Reloading $prog: "
- if ! LANG=$HTTPD_LANG $httpd $OPTIONS -t >&/dev/null; then
- RETVAL=$?
- echo $"not reloading due to configuration syntax error"
- failure $"not reloading $httpd due to configuration syntax error"
- else
- killproc -p ${pidfile} $httpd -HUP
- RETVAL=$?
- fi
- echo
- }
- # See how we were called.
- case "$1" in
- start)
- start
- ;;
- stop)
- stop
- ;;
- status)
- status -p ${pidfile} $httpd
- RETVAL=$?
- ;;
- restart)
- stop
- start
- ;;
- condrestart)
- if [ -f ${pidfile} ] ; then
- stop
- start
- fi
- ;;
- reload)
- reload
- ;;
- graceful|help|configtest|fullstatus)
- $apachectl $@
- RETVAL=$?
- ;;
- *)
- echo $"Usage: $prog {start|stop|restart|condrestart|reload|status|fullstatus|graceful|help|configtest}"
- exit 1
- esac
- exit $RETVAL
而后为此脚本赋予执行权限:
# chmod +x /etc/rc.d/init.d/httpd
加入服务列表:
# chkconfig --add httpd
设为开机启动:
#chkconfig httpd on
5、输出apache的man手册至man命令的查找路径:
编辑/etc/man.config,添加如下行即可:
MANPATH /usr/local/apache/man
6、输出apache的头文件至系统头文件路径/usr/include:
这可以通过简单的创建链接实现:
# ln -sv /usr/local/apache/include /usr/include/apache
7、修改PATH环境变量,让系统可以直接使用apache的相关命令。
在/etc/profile文件中添加以下内容:
PATH=$PATH:/usr/local/apache/bin
接下来就可以启动服务进行测试了。
#service httpd start
在浏览器中输入 172.16.4.1
表示apache安装成功!
二、安装mysql-5.5.20
1、准备数据存放的文件系统
新建一个逻辑卷,并将其挂载至特定目录即可。这里不再给出过程。这里假设其逻辑卷的挂载目录为/mysql,而后需要创建/mysql/data目录做为mysql数据的存放目录。
2、新建用户以安全方式运行进程:
# groupadd -r mysql
# useradd -g mysql -r -s /sbin/nologin -M -d /mysql/data mysql
# chown -R mysql:mysql /mysql/data
3、安装并初始化mysql-5.5.20
首先下载平台对应的mysql版本至本地,下载地址为:
http://www.mysql.com/downloads/mysql/
选择适应自身平台的mysql,这里笔者使用mysql-5.5.20-linux2.6-i686.tar.gz。
# tar xf mysql-5.5.20-linux2.6-i686.tar.gz -C /usr/local
# cd /usr/local/
# ln -sv mysql-5.5.20-linux2.6-i686 mysql
# cd mysql
# chown -R mysql:mysql .
# scripts/mysql_install_db --user=mysql --datadir=/mydata/data
# chown -R root .
4、为mysql提供主配置文件:
# cd /usr/local/mysql
# cp support-files/my-large.cnf /etc/my.cnf
并修改此文件中thread_concurrency的值为你的CPU个数乘以2,比如这里使用如下行:
thread_concurrency = 2
另外还需要添加如下行指定mysql数据文件的存放位置:
datadir = /mysql/data
5、为mysql提供sysv服务脚本:
# cd /usr/local/mysql
# cp support-files/mysql.server /etc/rc.d/init.d/mysqld
添加至服务列表:
# chkconfig --add mysqld
# chkconfig mysqld on
6、输出mysql的man手册至man命令的查找路径:
编辑/etc/man.config,添加如下行即可:
MANPATH /usr/local/mysql/man
7、输出mysql的头文件至系统头文件路径/usr/include:
这可以通过简单的创建链接实现:
# ln -sv /usr/local/mysql/include /usr/include/mysql
8、输出mysql的库文件给系统库查找路径:
# echo '/usr/local/mysql/lib' > /etc/ld.so.conf.d/mysql.conf
而后让系统重新载入系统库:
# ldconfig -v
9、修改PATH环境变量,让系统可以直接使用mysql的相关命令。
在/etc/profile文件中添加以下内容:
PATH=$PATH:/usr/local/mysql/bin
10、启动mysql
#service mysqld start
三、编译安装php-5.3.10
1、解决依赖关系:
由于编译安装php,需要用到X Software Development这个包组,因此需要事先安装这个包组,配置好yum源,执行以下命令:
# yum -y groupinstall "X Software Development"
如果想让编译的php支持mcrypt扩展,此处还需要下载如下两个rpm包并安装之:
libmcrypt-2.5.7-5.el5.i386.rpm
libmcrypt-devel-2.5.7-5.el5.i386.rpm
下载地址:http://down.51cto.com/data/361554
执行以下命令:
#rpm –ivh libmcrypt-2.5.7-5.el5.i386.rpm libmcrypt-devel-2.5.7-5.el5.i386.rpm
2、编译安装php-5.3.10
首先下载php-5.3.1源码包至本地目录,下载地址:
http://cn2.php.net/get/php-5.3.10.tar.bz2/from/this/mirror
执行以下命令:
# tar xf php-5.3.10.tar.bz2
# cd php-5.3.10
注:如果前面第1步解决依赖关系时安装mcrypt相关的两个rpm包,此./configure命令还可以带上--with-mcrypt选项以让php支持mycrpt扩展,如果没有安装则不需要带上—with-mcrpt这个选项,这里笔者已经安装所以带上—with-mcrpt选项。
- #./configure --prefix=/usr/local/php --with-mysql=/usr/local/mysql --with-openssl --with-mysqli=/usr/local/mysql/bin/mysql_config --enable-mbstring --with-freetype-dir --with-jpeg-dir --with-png-dir --with-zlib --with-libxml-dir=/usr --enable-xml --with-apxs2=/usr/local/apache/bin/apxs –with-mcrpt
- # make
- # make test
- # make intall
为php提供配置文件:
# cp php.ini-production /usr/local/php/lib/php.ini
3、 编辑apache配置文件httpd.conf,以apache支持php
# vim /etc/httpd/httpd.conf
1、添加如下二行
AddType application/x-httpd-php .php
AddType application/x-httpd-php-source .phps
2、定位至DirectoryIndex index.html
修改为:
DirectoryIndex index.php index.html
3、修改/usr/local/apache/htdocs/index.html
将其重命名为:index.php
#mv /usr/local/apache/htdocs/index.html /usr/local/apache/htdocs/index.php
编辑/usr/local/apache/htdocs/index.php添加以下内容:
<?php
Phpinfor();
?>
保存退出
而后重新启动httpd,或让其重新载入配置文件即可测试php是否已经可以正常使用。
在浏览器中输入172.16.4.1出现以下界面
证明php已经安装成功
4、验证是否可以成功连接至mysql
编辑/usr/local/apache/htdocs/index.php,添加以下内容:
<?php
$link=mysql_connect('localhost','root','');
if ($link)
echo "Successfuly";
else
echo "Faile";
mysql_close();
?>
保存退出。
在浏览器中输入 172.16.4.1,出现以下内容:
证明连接MySQL成功!
到此,LAMP平台搭建成功。
欢迎各位博友前来指出不足与缺陷,共同学习!